﻿//*****Constants
var SPACE='0'
var WALL='1'
var HOLDER='2'
var BOX='3'
var BOXREST='4'
var PLAYER='5'

var NORTH='1'
var SOUTH='2'
var EAST='3'
var WEST='4'
var PUSHNORTH='5'
var PUSHSOUTH='6'
var PUSHEAST='7'
var PUSHWEST='8'

var PUSHES=0;
var MOVES=1;
var SOLVETIME=2;
var SOLUTION=3;

//*****Global vars
var CurrLevel=0;
var CurrRow=0;
var CurrCol=0;
var Moves=new Array();
var MovesUndone=new Array();
var NoMoves=0;
var NoPushes=0;
var NoSeconds=0;
var SET = 1;
var StartTimer;
var Timerid;
var TheSolution;
var Playing=false;
var CounterOn=false;
var DirtyFlag=false;
var LoadingPack=false;
var Direction;
var newwin;
//window.onunload=SaveChanges;

//*******Save tdC changes to local disk - only in off-line mode
function SaveChanges()
{
	if(!DirtyFlag) return;
		//Don't prompt for save if on-line 
	/*
	if(location.protocol=='http:')
	{	
		// TODO: save records on server
		return;
	}
	*/
	SavePrompt="DHTML Sokoban\n\nYou have a record high score in one or more levels.\n\n"+
	"Would you like to save your score and solution ?";
	if(!(confirm(SavePrompt))) return;

	//***build text string for window write
	TextStr='var recordset = new Array();\n';

	for(i=1;i<LEVEL.length;i++)
	{
		if(recordset[i])
		{
			TextStr += 'recordset['+i+'] = "';
			TextStr += recordset[i] +'";\n';
		}
		else
		{
			TextStr += 'recordset['+i+'] = "";\n';
		}
	}

	var GamePath=location.pathname.substr(1);
	var LastSlash=GamePath.lastIndexOf("\\");
	GamePath=GamePath.substring(0,LastSlash+1);

	var HelpHTML ='<p>Since DHTML Sokoban has no permission to write data to your '+
	'hard disk, you will have to do the task manually. The data has been copied '+
	'to the pop-up window below. Follow the instructions '+
	'below to save your record high scores and solutions.</p>'+
	'<p><b>1:</b>Right-click the data window and choose "View Source" from the menu that appears.<br>'+
	'<b>2:</b>When Notepad appears, choose "File->Save As" in Notepad.<br>'+
	'<b>3:</b>Copy the data file path given below in the "File Name" box and overwrite the existing data file '+GamePath + document.getElementById('levels').dataURL+'</p>';

	var helpwin;
	var file = 'save.php?set='+SET+'&level='+CurrLevel+'&record='+recordset[CurrLevel];
	newwin = window.open(file,'Fenster','scrollbars=yes,status=no,width=450,height=200,top=300,left=150');
	setTimeout("processData()", 5000);
	helpwin=window.open('','Fenster2','scrollbars=yes,status=no,width=700,height=200,top=50,left=50');
	helpwin.document.write(HelpHTML);
	helpwin.document.close();
}

function processData()
{
	newwin.document.open("text/plain");
	newwin.document.write(TextStr)
	newwin.document.close();
	var lvl = (SET == 1) ? 'baselvlrecords' : 'yoshiolvlrecords';
	getNewRecords(lvl);
}

function getNewRecords(recordPage) 
{
	var levelfile = recordPage + ".js";
	var head = document.getElementsByTagName('head').item(0);
	var scripts = document.getElementsByTagName('script');
	for(var i=0; i<scripts.length; i++)
	{
		if(scripts[i].src.indexOf('lvlrecords') != -1)
		{
			head.removeChild(scripts[i]);
			break;
		}
	}
	var script = document.createElement('script');	
	script.src = levelPage + "records.js";
	script.type = 'text/javascript';	
	script.defer = true;	
	head.appendChild(script);
}

function GotoLevel()
{
	var newlevel=prompt('Enter Level Number','');
	if(newlevel)
		LoadLevel(newlevel*1)
}

function PlaySolution()
{
	LoadLevel(CurrLevel);
	Playing = false;
	ScoreStr = recordset[CurrLevel];
	if(ScoreStr == '') 
	{
		alert('This level is not solved previously.\nTherefore no Solution is available for this level');
		return;
	}
	RecordArray = ScoreStr.split(":");
	TheSolution = RecordArray[SOLUTION];
	MakeMove();
}

function MakeMove()
{
	if(Playing) return;
	if(NoMoves==TheSolution.length) return;
	var Movedir = TheSolution.substr(NoMoves,1)
	Movedir--;
	Movedir=Movedir % 4;
	Movedir++;
	Navigate(String(Movedir));
	setTimeout("MakeMove()",300)
}

//***************Instructions
function Instructions()
{
	IStr= 'Sokoban is Japanese for warehouse keeper.  This classic puzzle\n'+
	'was invented by Hiroyuki Imabayashi, president of Thinking Rabbit\n'+
	'Inc. Japan, in 1982. The object of the game is to cover all the\n'+
	'blue holders (X) by moving the boxes over them. Following are\n'+
	'the rules of the game :\n\n'+
	'1. You can move boxes by pushing them using the arrow keys.\n'+
	'2. You can only push one box at a time.\n'+
	'3. The level is won when all the blue holders are covered.\n\n'+
	'Sometimes there might be more boxes than box holders.  This\n'+
	'usually is a trick - some of the boxes will be placed in such a\n'+
	'manner that it is impossible to get them over a holder.\n\n'+
	'Sometimes you may push a box into a corner, or against another\n'+
	'box in such a way that it is impossible to further move the box.\n'+
	'In that case click Undo.  You can Undo all the way to the beginning\n'+
	'of the game.\n\n'+
	'When you solve a level, the solution for that level is recorded for\n'+
	'you, so you can play it back later. If you are playing off-line,\n'+
	'you will be prompted to save the solution to your hard disk. Should\n'+
	'you choose not to save, you will not be able to play back your\n'+
	'solutions the next time you play the game.';
	alert(IStr);
}


//****************Undo
function DoUndo()
{
	if(!Playing) return;
	if(NoMoves<=0) return;
	var LastMove=Moves.pop();
	switch(LastMove)
	{
		case NORTH:
			RefreshCell(CurrRow,CurrCol);
			document.getElementById('R'+(CurrRow+1)+'C'+CurrCol).src='media/north.gif';
			CurrRow++;
			break;

		case SOUTH:
			RefreshCell(CurrRow,CurrCol);
			document.getElementById('R'+(CurrRow-1)+'C'+CurrCol).src='media/south.gif';
			CurrRow--;
			break;

		case EAST:
			RefreshCell(CurrRow,CurrCol);
			document.getElementById('R'+(CurrRow)+'C'+(CurrCol-1)).src='media/east.gif';
			CurrCol--;
			break;

		case WEST:
			RefreshCell(CurrRow,CurrCol);
			document.getElementById('R'+(CurrRow)+'C'+(CurrCol+1)).src='media/west.gif';
			CurrCol++;
			break;

		case PUSHNORTH:
			RefreshCell(CurrRow-1,CurrCol);
			if(document.getElementById('R'+(CurrRow)+'C'+CurrCol).celltype==HOLDER){
				document.getElementById('R'+(CurrRow)+'C'+CurrCol).src='media/boxrest.gif';
				document.getElementById('R'+(CurrRow)+'C'+CurrCol).celltype=BOXREST;
				}
			else{
				document.getElementById('R'+(CurrRow)+'C'+CurrCol).src='media/box.gif';
				document.getElementById('R'+(CurrRow)+'C'+CurrCol).celltype=BOX;
				}

			document.getElementById('R'+(CurrRow+1)+'C'+CurrCol).src='media/north.gif';
			CurrRow++;
			NoPushes--;
			document.getElementById('PushDiv').innerHTML=NoPushes;
			break;

		case PUSHSOUTH:
			RefreshCell(CurrRow+1,CurrCol);
			if(document.getElementById('R'+(CurrRow)+'C'+CurrCol).celltype==HOLDER){
				document.getElementById('R'+(CurrRow)+'C'+CurrCol).src='media/boxrest.gif';
				document.getElementById('R'+(CurrRow)+'C'+CurrCol).celltype=BOXREST;
				}
			else{
				document.getElementById('R'+(CurrRow)+'C'+CurrCol).src='media/box.gif';
				document.getElementById('R'+(CurrRow)+'C'+CurrCol).celltype=BOX;
				}
			document.getElementById('R'+(CurrRow-1)+'C'+CurrCol).src='media/south.gif';
			CurrRow--;
			NoPushes--;
			document.getElementById('PushDiv').innerHTML=NoPushes;
			break;

		case PUSHEAST:
			RefreshCell(CurrRow,CurrCol+1);
			if(document.getElementById('R'+(CurrRow)+'C'+CurrCol).celltype==HOLDER){
				document.getElementById('R'+(CurrRow)+'C'+CurrCol).src='media/boxrest.gif';
				document.getElementById('R'+(CurrRow)+'C'+CurrCol).celltype=BOXREST;
				}
			else{
				document.getElementById('R'+(CurrRow)+'C'+CurrCol).src='media/box.gif';
				document.getElementById('R'+(CurrRow)+'C'+CurrCol).celltype=BOX;
				}
			document.getElementById('R'+(CurrRow)+'C'+(CurrCol-1)).src='media/east.gif';
			CurrCol--;
			NoPushes--;
			document.getElementById('PushDiv').innerHTML=NoPushes;
			break;

		case PUSHWEST:
			RefreshCell(CurrRow,CurrCol-1);
			if(document.getElementById('R'+(CurrRow)+'C'+CurrCol).celltype==HOLDER){
				document.getElementById('R'+(CurrRow)+'C'+CurrCol).src='media/boxrest.gif';
				document.getElementById('R'+(CurrRow)+'C'+CurrCol).celltype=BOXREST;
				}
			else{
				document.getElementById('R'+(CurrRow)+'C'+CurrCol).src='media/box.gif';
				document.getElementById('R'+(CurrRow)+'C'+CurrCol).celltype=BOX;
				}
			document.getElementById('R'+(CurrRow)+'C'+(CurrCol+1)).src='media/west.gif';
			CurrCol++;
			NoPushes--;
			document.getElementById('PushDiv').innerHTML=NoPushes;
			break;

		}
	NoMoves--;
	MovesUndone.unshift(LastMove);
	document.getElementById('MoveDiv').innerHTML=NoMoves;
}

//****************Redo
function DoRedo()
{
	if(!Playing) return;
	if(MovesUndone.length<=0) return;
	var Movedir = MovesUndone.shift();
	Movedir--;
	Movedir=Movedir % 4;
	Movedir++;
	Navigate(String(Movedir));
}

function UpdateTimeDiv()
{
	var CurrTimer=new Date()
	NoSeconds=Math.round((CurrTimer-StartTimer)/1000);;
	dispsecs=NoSeconds%60
	dispmins=Math.floor(NoSeconds/60)
	document.getElementById('TimeDiv').innerHTML=dispmins+":"+dispsecs;
}

//*************** Level has been solved
function WinGame()
{
	if(!Playing) return;
	Playing=false;
	CounterOn=false;
	clearInterval(Timerid);
	var ScoreStr = recordset[CurrLevel];

	if(ScoreStr=='')
		RecordScore();
	else
	{
	  RecordArray=ScoreStr.split(":");
	  if(NoPushes>RecordArray[PUSHES]) return;
	  if(NoPushes<RecordArray[PUSHES]) {RecordScore();return;}
	  if(NoMoves>RecordArray[MOVES]) return;
	  if(NoMoves<RecordArray[MOVES]) {RecordScore();return;}
	  if(NoSeconds>RecordArray[SOLVETIME]) return;
	  if(NoSeconds<RecordArray[SOLVETIME]) {RecordScore();return;}
  }


}

//************* Record High Score
function RecordScore()
{
	DirtyFlag=true;
	alert('Congratulations!\n\nYou have recorded the highest score for this level.');
	recordset[CurrLevel] = NoPushes + ":" + NoMoves + ":" + NoSeconds + ":" + Moves.join('');
	SaveChanges();
}

//*****************Register Move
function IncMoves(movedir)
{
	if(!CounterOn) 
	{
		StartTimer=new Date();
		CounterOn=true;
		if(Playing)
		Timerid=setInterval("UpdateTimeDiv()",1000);
	}
	NoMoves++;
	Moves.push(movedir);
	document.getElementById('MoveDiv').innerHTML=NoMoves;
	if(movedir>4)
		document.getElementById('PushDiv').innerHTML=++NoPushes
	for(i=0;i<15;i++)
		for(j=0;j<15;j++)
			if(document.getElementById('R'+i+'C'+j).celltype==HOLDER)
				return;

	WinGame();
}


//*****************Load Game Pack
function changeLevelset(levelPage) 
{
	var levelfile = levelPage + ".js";
	SET = (levelPage.indexOf('base') != -1) ? 1 : 2;
	var head = document.getElementsByTagName('head').item(0);
	var scripts = document.getElementsByTagName('script');
	for(var i=0; i<scripts.length; i++)
	{
		if(scripts[i].src.indexOf('lvl.js') != -1)
		{
			head.removeChild(scripts[i]);
			break;
		}
	}
	var script = document.createElement('script');	
	script.src = levelfile;	
	script.type = 'text/javascript';	
	script.defer = true;	
	head.appendChild(script);
	script = document.createElement('script');	
	script.src = levelPage + "records.js";
	script.type = 'text/javascript';	
	script.defer = true;	
	head.appendChild(script);
	LoadPack(levelPage + "records.js");
	DataLoaded();
}

function LoadPack(packname)
{
	SaveChanges();
	DirtyFlag=false;
	LoadingPack=true;
	document.getElementById('levels').dataURL=packname;
}

function DataLoaded()
{
	if(!LoadingPack) return;
	LoadingPack=false; 
	setTimeout("LoadLevel(1)",500);
}

function RandomLevel()
{
	var level = Math.ceil(Math.random()*LEVEL.length);
	if(level >= LEVEL.length)
		level = 1;
	return level;
}

function LoadLevel(level)
{
//Initialize Playing Field
	Playing=false;
	CounterOn=false;
	clearInterval(Timerid);
	NoMoves=0;
	NoPushes=0;
	Moves.length=0;
	document.getElementById('MoveDiv').innerHTML = "0";
	document.getElementById('PushDiv').innerHTML = "0";
	document.getElementById('TimeDiv').innerHTML = "0:0";
	
	if(level >= LEVEL.length)
	{
		level = 1;
		alert('You are at the end of the Level-set. You will continue with with level 1');
	}
	if(level <= 0)
	{
		level = LEVEL.length - 1;
		alert('You are at the start of the Level-set. You will continue with level ' + (LEVEL.length - 1));
	}
	CurrLevel=level;
	document.getElementById('LevelDiv').innerHTML=CurrLevel;
	var c = 0;
	while(c<LEVEL[level].length)
	{
		datastr=LEVEL[level][c];
		for(i=0; i<LEVEL[level][c].length; i++)
		{
			switch(datastr.substr(i,1))
			{
				case WALL:
				  document.getElementById('R'+c+'C'+i).src='media/wall.gif';
				  document.getElementById('R'+c+'C'+i).celltype=WALL;
				  break;
				case HOLDER:
				  document.getElementById('R'+c+'C'+i).src='media/target.gif';
				  document.getElementById('R'+c+'C'+i).celltype=HOLDER;
				  break;
				case BOX:
				  document.getElementById('R'+c+'C'+i).src='media/box.gif';
				  document.getElementById('R'+c+'C'+i).celltype=BOX;
				  break;
				case PLAYER:
				  document.getElementById('R'+c+'C'+i).src='media/north.gif';
				  CurrRow=c;
				  CurrCol=i;	
				  break;
				default:
				  document.getElementById('R'+c+'C'+i).src='media/trans.gif';
				  document.getElementById('R'+c+'C'+i).celltype=SPACE;
			}
		}
		c++;
	}
	Playing=true;
}

//*****************Make Game Grid
function MakeGrid()
{
	//Preload Images
	img1=new Image();img1.src='media/south.gif';
	img2=new Image();img2.src='media/west.gif';
	img3=new Image();img3.src='media/east.gif';
	img4=new Image();img4.src='media/boxrest.gif';

	HTMLStr='<table id="board" cellpadding="0" cellspacing="0" width="100%" border="0">';
	for(i=0;i<15;i++)
	{
		HTMLStr+='<tr>';
		for(j=0;j<15;j++)
			HTMLStr+='<td><img id="R'+i+'C'+j+'" src="media/trans.gif" width="34" height="34" border="0"></td>'
		HTMLStr+='<\/tr>';
	}
	HTMLStr+='<\/table>';
	document.getElementById('gamezone').innerHTML=HTMLStr;
	var scripts = document.getElementsByTagName('script');
	var levelfile = scripts[1].src.substring(scripts[1].src.lastIndexOf('/')+1)
	LoadPack(levelfile);
	DataLoaded();
}

//*********RefreshCell - support fn for navigation
function RefreshCell(R,C)
{
	datastr=LEVEL[CurrLevel][R];
	datastr=datastr.substr(C,1);
	if(datastr==HOLDER)
	{
		document.getElementById('R'+R+'C'+C).src='media/target.gif';
		document.getElementById('R'+R+'C'+C).celltype=HOLDER;
	}
	else
	{
		document.getElementById('R'+R+'C'+C).src='media/trans.gif';
		document.getElementById('R'+R+'C'+C).celltype=SPACE;
	}
}


//***************Navigation
var ie = (navigator.appName.indexOf("Microsoft") != -1) ? 1 : 0;
if(!ie)
{
	document.addEventListener("keydown", keyDown, true);
}
else
{
	document.attachEvent("onkeydown", keyDown);
}
function keyDown(e)
{
	if(!Playing)
	{	
		alert('You have to restart the level!');
		return;
	}
	switch(e.keyCode)
	{
		case 37:Direction=WEST;break;
		case 38:Direction=NORTH;break;
		case 39:Direction=EAST;break;
		case 40:Direction=SOUTH;break;
	}
	Navigate(Direction);
}

function Navigate(Direction)
{
	switch(Direction)
	{
		case WEST: //Left
		  if(CurrCol==0) return;
		  if(document.getElementById('R'+CurrRow+'C'+(CurrCol-1)).celltype==WALL) return;
		  if((document.getElementById('R'+CurrRow+'C'+(CurrCol-1)).celltype==SPACE)
			||(document.getElementById('R'+CurrRow+'C'+(CurrCol-1)).celltype==HOLDER)){
			RefreshCell(CurrRow,CurrCol);
			document.getElementById('R'+CurrRow+'C'+(CurrCol-1)).src='media/west.gif';
			IncMoves(WEST);
			CurrCol--;return;
			}
		  if((document.getElementById('R'+CurrRow+'C'+(CurrCol-1)).celltype==BOX)
		   ||(document.getElementById('R'+CurrRow+'C'+(CurrCol-1)).celltype==BOXREST)){
			if(CurrCol==1) return;
			if((document.getElementById('R'+CurrRow+'C'+(CurrCol-2)).celltype==SPACE)
			 ||(document.getElementById('R'+CurrRow+'C'+(CurrCol-2)).celltype==HOLDER)){
				RefreshCell(CurrRow,CurrCol);RefreshCell(CurrRow,CurrCol-1);
				document.getElementById('R'+CurrRow+'C'+(CurrCol-1)).src='media/west.gif';
				if(document.getElementById('R'+CurrRow+'C'+(CurrCol-2)).celltype==SPACE){
					document.getElementById('R'+CurrRow+'C'+(CurrCol-2)).src='media/box.gif';
					document.getElementById('R'+CurrRow+'C'+(CurrCol-2)).celltype=BOX;
					}
				else {
					document.getElementById('R'+CurrRow+'C'+(CurrCol-2)).src='media/boxrest.gif';
					document.getElementById('R'+CurrRow+'C'+(CurrCol-2)).celltype=BOXREST;
					}
				IncMoves(PUSHWEST);
				CurrCol--;return;
				}
			
			}
		  break;


		case NORTH: //Up
		  if(CurrRow==0) return;
		  if(document.getElementById('R'+(CurrRow-1)+'C'+(CurrCol)).celltype==WALL) return;
		  if((document.getElementById('R'+(CurrRow-1)+'C'+(CurrCol)).celltype==SPACE)
			||(document.getElementById('R'+(CurrRow-1)+'C'+(CurrCol)).celltype==HOLDER)){
			RefreshCell(CurrRow,CurrCol);
			document.getElementById('R'+(CurrRow-1)+'C'+(CurrCol)).src='media/north.gif';
			IncMoves(NORTH);
			CurrRow--;return;
			}
		  if((document.getElementById('R'+(CurrRow-1)+'C'+(CurrCol)).celltype==BOX)
		   ||(document.getElementById('R'+(CurrRow-1)+'C'+(CurrCol)).celltype==BOXREST)){
			if(CurrRow==1) return;
			if((document.getElementById('R'+(CurrRow-2)+'C'+(CurrCol)).celltype==SPACE)
			 ||(document.getElementById('R'+(CurrRow-2)+'C'+(CurrCol)).celltype==HOLDER)){
				RefreshCell(CurrRow,CurrCol);RefreshCell(CurrRow-1,CurrCol);
				document.getElementById('R'+(CurrRow-1)+'C'+(CurrCol)).src='media/north.gif';
				if(document.getElementById('R'+(CurrRow-2)+'C'+(CurrCol)).celltype==SPACE){
					document.getElementById('R'+(CurrRow-2)+'C'+(CurrCol)).src='media/box.gif';
					document.getElementById('R'+(CurrRow-2)+'C'+(CurrCol)).celltype=BOX;
					}
				else {
					document.getElementById('R'+(CurrRow-2)+'C'+(CurrCol)).src='media/boxrest.gif';
					document.getElementById('R'+(CurrRow-2)+'C'+(CurrCol)).celltype=BOXREST;
					}
				IncMoves(PUSHNORTH);
				CurrRow--;return;
				}
			
			}
		  break;

		case EAST: //Right
		  if(CurrCol==14) return;
		  if(document.getElementById('R'+(CurrRow)+'C'+(CurrCol+1)).celltype==WALL) return;
		  if((document.getElementById('R'+(CurrRow)+'C'+(CurrCol+1)).celltype==SPACE)
			||(document.getElementById('R'+(CurrRow)+'C'+(CurrCol+1)).celltype==HOLDER)){
			RefreshCell(CurrRow,CurrCol);
			document.getElementById('R'+(CurrRow)+'C'+(CurrCol+1)).src='media/east.gif';
			IncMoves(EAST);
			CurrCol++;return;
			}
		  if((document.getElementById('R'+(CurrRow)+'C'+(CurrCol+1)).celltype==BOX)
		   ||(document.getElementById('R'+(CurrRow)+'C'+(CurrCol+1)).celltype==BOXREST)){
			if(CurrCol==13) return;
			if((document.getElementById('R'+(CurrRow)+'C'+(CurrCol+2)).celltype==SPACE)
			 ||(document.getElementById('R'+(CurrRow)+'C'+(CurrCol+2)).celltype==HOLDER)){
				RefreshCell(CurrRow,CurrCol);RefreshCell(CurrRow,CurrCol+1);
				document.getElementById('R'+(CurrRow)+'C'+(CurrCol+1)).src='media/east.gif';
				if(document.getElementById('R'+(CurrRow)+'C'+(CurrCol+2)).celltype==SPACE){
					document.getElementById('R'+(CurrRow)+'C'+(CurrCol+2)).src='media/box.gif';
					document.getElementById('R'+(CurrRow)+'C'+(CurrCol+2)).celltype=BOX;
					}
				else {
					document.getElementById('R'+(CurrRow)+'C'+(CurrCol+2)).src='media/boxrest.gif';
					document.getElementById('R'+(CurrRow)+'C'+(CurrCol+2)).celltype=BOXREST;
					}
				IncMoves(PUSHEAST);
				CurrCol++;return;
				}
			
			}
		  break;


		case SOUTH: //Dn

		  if(CurrRow==14) return;
		  if(document.getElementById('R'+(CurrRow+1)+'C'+(CurrCol)).celltype==WALL) return;
		  if((document.getElementById('R'+(CurrRow+1)+'C'+(CurrCol)).celltype==SPACE)
			||(document.getElementById('R'+(CurrRow+1)+'C'+(CurrCol)).celltype==HOLDER)){
			RefreshCell(CurrRow,CurrCol);
			document.getElementById('R'+(CurrRow+1)+'C'+(CurrCol)).src='media/south.gif';
			CurrRow++;
			IncMoves(SOUTH);
			return;
			}
		  if((document.getElementById('R'+(CurrRow+1)+'C'+(CurrCol)).celltype==BOX)
		   ||(document.getElementById('R'+(CurrRow+1)+'C'+(CurrCol)).celltype==BOXREST)){
			if(CurrRow==13) return;
			if((document.getElementById('R'+(CurrRow+2)+'C'+(CurrCol)).celltype==SPACE)
			 ||(document.getElementById('R'+(CurrRow+2)+'C'+(CurrCol)).celltype==HOLDER)){
				RefreshCell(CurrRow,CurrCol);RefreshCell(CurrRow+1,CurrCol);
				document.getElementById('R'+(CurrRow+1)+'C'+(CurrCol)).src='media/south.gif';
				if(document.getElementById('R'+(CurrRow+1)+'C'+(CurrCol)).celltype==SPACE){
					document.getElementById('R'+(CurrRow+2)+'C'+(CurrCol)).src='media/box.gif';
					document.getElementById('R'+(CurrRow+2)+'C'+(CurrCol)).celltype=BOX;
					}
				else {
					document.getElementById('R'+(CurrRow+2)+'C'+(CurrCol)).src='media/boxrest.gif';
					document.getElementById('R'+(CurrRow+2)+'C'+(CurrCol)).celltype=BOXREST;
					}
				IncMoves(PUSHSOUTH);
				CurrRow++;return;
				}
			
			}
		  break;
	}
}